var WS = "ws://www.chabloz.eu:8080";

// Variables globales
var templateMsg;
var templateUser;
var webSocket;

$.holdReady(true);

function createWebSocket () {
    webSocket = new WebSocket(WS);
    webSocket.onopen = function(e) {
        console.log('connection successful');
        $.holdReady(false);
    };
    webSocket.onclose = function(e) {
        console.log('disconnection successful');
    };
    webSocket.onmessage = function(response) {
        var result = JSON.parse(response.data);
        console.log('recieved: ');
        console.log(result);
        if (result.status == 'error') {
            return
        }
        console.log('trigger ' + result.action);
        $('#chat').trigger(result.action, result.data);
    };
    webSocket.sendJson = function (data) {
        var sending = JSON.stringify(data);
        console.log('sending: ');
        console.log(sending)
        this.send(sending);
    }
}

createWebSocket();

$(function () {
    templateMsg = $(".templateMsg").clone();
    templateMsg.removeClass('template');
    templateUser = $(".templateUser").clone();
    templateUser.removeClass('template');
    $("#nickname").focus();
    $("#btnLogin").on("click", login);
    $("#btnLogout").on("click", logout);
    $("#nickname").on("keyup", loginOnEnter);
    $("#msg").on("keyup", sendOnEnter);
    $("#btnSend").on("click", sendMsg);
    $("#chat").on("login", function () {
        $("#login").hide();
        $("#chat").show();
        $("#messages").empty();
        $("#msg").val('');
        $("#msg").focus();
    });
    $("#chat").on("logout", function () {
        createWebSocket();
        $("#chat").hide();
        $("#login").show();
        $("#nickname").focus();
    })
    $("#chat").on("send", function (evt, data) {
        addMsg(data);
    });
    $("#chat").on("connection", function (evt, username) {
        addUser(username);
    });
    $("#chat").on("disconnection", function (evt, username) {
        removeUser(username);
    });
})


function sendMsg() {
    var msg = $("#msg").val();
    webSocket.sendJson({
        action: "send",
        msg: msg
    });
    $("#msg").val('');
    $("#msg").focus();
}

function addMsg(data) {
    var tmpl = templateMsg.clone();
    $(".username", tmpl).text(data.username);
    $(".message", tmpl).text(data.msg);
    tmpl.appendTo("#messages");
    // auto-scroll vers le bas du chat
    $("#messages").scrollTop($("#messages").prop('scrollHeight'));
}

function addUser(username) {
    var tmpl = templateUser.clone();
    tmpl.attr('id', username);
    $(".usernameOnline", tmpl).text(username);
    tmpl.appendTo("#usersList");
}

function removeUser(username) {
    $('#' + username).remove();
}

function loginOnEnter(event) {
    var charCode = (event.which) ? event.which : event.keyCode;
    if (charCode == 13) {
       login();
    }
}

function sendOnEnter(event) {
    var charCode = (event.which) ? event.which : event.keyCode;
    if (charCode == 13) {
        sendMsg();
    }
}

function login() {
    var user = $("#nickname").val();
    $(".warning").hide();
    // Verification que des caractères
    if (!user.match(/^[a-z]+$/i)) {
        $("#warnFormat").show();
        return;
    }
    webSocket.sendJson({
        action: "connect",
        username: user
    });
}

function logout() {
    webSocket.close();
    $("#chat").trigger("logout")
}